/****************************************************************
* Projectname:        Testprogram for Fischertechnik-Interface
* Moduldescription:   Sourcefile (uses interface.dll)
*----------------------------------------------------------------
* Internal functions:
* External functions:
*
* Modulname:          intertest.cpp
* Targettyp:          EXE
* Ident:              04.05.2000
* Company:            Maier Software & Hardware
* Adress:             Nieder-Wllstdter Strae 16, 61194 Niddatal, Germany
* Phone:              (0049 60 34) 92 186
* E-Mail:             Dirk.Maier.MSH@t-online.de
* Author:             Dirk Maier
* Modification:       12.06.2000
*                     15.09.2000  Erweiterung auf Mehrsprachigkeit
*                                 COM und Interface in *.CFG Datei abgelegt
*
****************************************************************/

#include <windows.h>
#include <commdlg.h>

#include <stdio.h>

#include "intertest.h"
#include "interface.h"   // von interface.DLL

/**************************************************************/
// Definitionen
#define EDITID   1
#define UNTITLED TEXT ("(unbenannt)")

//#define TEXT           // um ohne TEXT-Makro zu kompilieren aktivieren

/**************************************************************/
// Prototypen

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

/**************************************************************/
// Globale Variablen
TCHAR      szAppName[] = TEXT ("Haupt") ;
HINSTANCE  hAppInstance;

/**************************************************************/
// Interne Variablen
static WORD uiComport;                 // 0 = keins, 1-4 = COM 1-4
static WORD uiInterface;               // 0 = keins, 1 = Master Interface, 2 = Master und Slave Interface

static HINSTANCE hLibrary;
static HANDLE    hFile;
static DWORD     dwNumberOfBytes;
static FI_INTERFACE fi_interface;

/***************************************************************************************************/
// Hauptprogramm
/***************************************************************************************************/

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
  MSG       msg ;
  HWND      hWnd ;
  WNDCLASS  wndclass ;
  WORD      Primary_Language_ID;
  HMENU     hMenu;

  {hInstance; szCmdLine;}                    // Um Warnungen des Compilers zu vermeiden

  // Programmvariablen initialisieren
  hAppInstance = hInstance;                  // Instanz der Applikation

  // Programmvariablen aus Datei laden
  hFile = CreateFile(TEXT("INTERTEST.CFG"),GENERIC_READ | GENERIC_WRITE,
                     0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
  if (hFile)
   {// Daten aus File lesen
    ReadFile(hFile,&uiComport,sizeof(uiComport),&dwNumberOfBytes,NULL);
    if ((dwNumberOfBytes == 0) || (uiComport > 4))
      uiComport = 2;                           // COM2 als Vorgabe

    ReadFile(hFile,&uiInterface,sizeof(uiInterface),&dwNumberOfBytes,NULL);
    if ((dwNumberOfBytes == 0) || (uiInterface > 2))
      uiInterface = 1;                         // ein Interface installiert als Vorgabe
   }
   else
   {// Default setzen, wenn File nicht gefunden !
    uiComport = 2;                             // COM2 als Vorgabe
    uiInterface = 1;                           // ein Interface installiert als Vorgabe
   }

  // DLL der entsprechenden Sprache laden
  Primary_Language_ID = WORD(PRIMARYLANGID(GetSystemDefaultLangID()));
  if (Primary_Language_ID == LANG_GERMAN)
    hLibrary = LoadLibrary(TEXT("INTERTEST_DEUTSCH.DLL"));
   else
    hLibrary = LoadLibrary(TEXT("INTERTEST_ENGLISCH.DLL"));

  // Fensterklasse initialisieren
  if (!hPrevInstance)
   {wndclass.style         = CS_HREDRAW | CS_VREDRAW;    // Fensterinhalt zentral darstellen
    wndclass.lpfnWndProc   = WndProc;                    // Funktion der Fensterklasse
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = 0;
    wndclass.hInstance     = hInstance;                  // Handle der Fensterklasse
    wndclass.hIcon         = LoadIcon (hLibrary, TEXT("Prog_Icon")) ;  // Fenster - Icon
    wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);             // Fenster - Pointer
    wndclass.hbrBackground	= (HBRUSH)GetStockObject (DKGRAY_BRUSH );   // Fensterhintergrundfarbe
    wndclass.lpszMenuName  = "";                                       // Hauptmenue (wird aus DLL geladen)
    wndclass.lpszClassName = szAppName ;                               // Klassenname

    if (!RegisterClass (&wndclass))
     {// UNICODE-Compilierung ist die einzige realistische Fehlermglichkeit
      if (Primary_Language_ID == LANG_GERMAN)
        MessageBox (NULL, TEXT ("Programm arbeitet mit Unicode und setzt Windows NT voraus!"),
                    szAppName, MB_ICONERROR) ;
       else
        MessageBox (NULL, TEXT ("program works with unicode and needs Windows NT !"),
                    szAppName, MB_ICONERROR) ;
      return 0 ;
     }
   }

  // Hauptfenster der Anwendung erzeugen
  hWnd = CreateWindow( szAppName,					   // Fensterklassenname
    					     TEXT("Interface - Demo"),	// Titelleiste
    					     WS_OVERLAPPEDWINDOW,        // Fensterstil
    					     CW_USEDEFAULT,		         // Fensterposition, x
                       CW_USEDEFAULT,				   // Fensterposition, y
                       CW_USEDEFAULT,				   // horizontale Groesse
                       CW_USEDEFAULT,				   // vertikale Groesse
                       NULL,						      // Handle Parent-Window
                       NULL,						      // Handle Menue
                       hInstance,				   	// Handle Programmkopie
                       NULL);				      		// Spezialparameter

  // Hauptmenue aus DLL laden und setzen
  hMenu = LoadMenu(hLibrary,TEXT("Menu1"));
  SetMenu(hWnd, hMenu);

  // Hauptfenster der Anwendung anzeigen
  ShowWindow (hWnd,iCmdShow);	   		  			   // Darstellung des Hauptfensters.
													            // maximal: nCmdShow = SW_SHOWMAXIMIZED
													            // inaktiv: nCmdShow = SW_SHOWMINNOACTIVE
													            // normal : nCmdShow = SW_SHOWNORMAL

  UpdateWindow (hWnd);	    						      // Fensterinhalt ausgeben

  //Ereignis-Schleife
  while (GetMessage (&msg, NULL, 0, 0))            // Message einlesen
   {
    if (!IsDialogMessage(hWnd,&msg))
     {
      TranslateMessage (&msg) ;                    // Message auf Tastatur umsetzen
      DispatchMessage (&msg) ;                     // Message an entspr. Funktion weiterleiten
     }
   }
  return msg.wParam ;
}

/***************************************************************************************************/
// Unterroutinen
/***************************************************************************************************/

BOOL CALLBACK AboutDlgProc (HWND hDlg, UINT message,
                            WPARAM wParam, LPARAM lParam)
{
  {lParam;}                    // Um Warnungen des Compilers zu vermeiden
  switch (message)
   {
    case WM_INITDIALOG:
         return TRUE ;

    case WM_COMMAND:
         switch (LOWORD (wParam))
          {
           case IDOK:
                EndDialog (hDlg, 0) ;
                return TRUE ;
          }
         return 0;
   }
  return FALSE ;
}

/***************************************************************************************************/

BOOL CALLBACK InterfaceRecallDlgProc (HWND hDlg, UINT message,
                                      WPARAM wParam, LPARAM lParam)
{
  HWND  hControl;
  char cNrStr[20];
  int i;

  {lParam;}                    // Um Warnungen des Compilers zu vermeiden


  switch (message)
   {
    case WM_INITDIALOG:
         if(fi_interface.hComport) return FALSE;    //Schnittstelle noch offen
         memset (&fi_interface, 0, sizeof(fi_interface));
         InitInterfaceDriver (hDlg, uiComport, uiInterface,&fi_interface);
         SetTimer(hDlg,1,100,0);
         return TRUE ;

    case WM_COMMAND:
         switch (LOWORD (wParam))
          {
           case ID_START:
                StartRecallInterface(ICOMMAND_DIN, &fi_interface);
                return TRUE ;

           case ID_STOP:
                EndRecallInterface(&fi_interface);
                return TRUE ;

           case ID_CLEAR:
                for (i=0; i<16; i++) fi_interface.dwCount[i] = 0;
                return TRUE ;
          }
         return 0;

    case WM_CLOSE:
         EndDialog (hDlg, 0) ;
         return TRUE ;

    case WM_TIMER:

         sprintf(cNrStr,"%u",fi_interface.dwCount[0]);
         hControl = GetDlgItem(hDlg,IDC_COUNTER);
         SetWindowText(hControl,TEXT(cNrStr));

         sprintf(cNrStr,"%u",fi_interface.dwFrequenz[0]);
         hControl = GetDlgItem(hDlg,IDC_FREQUENZ);
         SetWindowText(hControl,TEXT(cNrStr));

         sprintf(cNrStr,"%u",fi_interface.dwPeriode[0]);
         hControl = GetDlgItem(hDlg,IDC_PERIOD);
         SetWindowText(hControl,TEXT(cNrStr));

         return TRUE;

    case WM_DESTROY:
         CloseInterfaceDriver(&fi_interface);
         return TRUE ;
   }
  return FALSE ;
}

/***************************************************************************************************/
// Auswertung der Message-Loop vom Hauptfenster
/***************************************************************************************************/

LRESULT CALLBACK WndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  static HINSTANCE hInst ;

  switch (message)
   {
    case WM_CREATE:
         hInst = ((LPCREATESTRUCT) lParam) -> hInstance ;
         return 0 ;

    case WM_COMMAND:
         switch (LOWORD (wParam))
          {
           //****** Men-Funktionen *******
           case IDM_APP_EXIT:
                SendMessage (hWnd, WM_CLOSE, 0, 0) ;
                break;

           case IDM_APP_PARAMETER:
                ParameterWahl (hWnd, &uiComport, &uiInterface);
                break;

           case IDM_APP_DIAGNOSE:
                InterfaceDiagnoseStart (hWnd, uiComport, uiInterface);
                break;

           case IDM_APP_RECALL:
                DialogBox(hLibrary, TEXT("IDD_Recall"),hWnd,(DLGPROC)InterfaceRecallDlgProc);
                break;

                // Hilfestellung
           case IDM_APP_ABOUT:
                DialogBox(hLibrary, TEXT("IDD_About_Box"),hWnd,(DLGPROC)AboutDlgProc);
                break;
          }
         return 0;

    case WM_DESTROY:
         if (hLibrary) FreeLibrary (hLibrary);
         if (hFile)
          {
           SetFilePointer (hFile, 0, NULL, FILE_BEGIN);  // an Fileanfang setzen
           WriteFile(hFile,&uiComport,sizeof(uiComport),&dwNumberOfBytes,NULL);
           WriteFile(hFile,&uiInterface,sizeof(uiInterface),&dwNumberOfBytes,NULL);
           CloseHandle(hFile);
          }
         PostQuitMessage (0) ;
         return 0 ;
   }
  return DefWindowProc (hWnd, message, wParam, lParam) ;
}

/***************************************************************************************************/

